Package com.norconex.commons.lang.io

# Class ByteArrayOutputStream

java.lang.Object
java.io.OutputStream
com.norconex.commons.lang.io.ByteArrayOutputStream

All Implemented Interfaces:
  `Closeable`, `Flushable`, `AutoCloseable`

public class ByteArrayOutputStream extends OutputStream

This class is an alternate version of Java `ByteArrayOutputStream`. This code is derived from the Apache `ByteArrayOutputStream`. Like the Apache version, this class creates new byte arrays as it grows without copying them into a larger one (for better performance). Each new array is stored in a list.

In addition to the Apache version, this class offers methods to access subsets of bytes ranging form zero to the total number of bytes written so far. Also different, each byte array created have the same length, matching the initial capacity provided (default is 1024).

The higher the initial capacity, the faster it should be to write large streams, but the more initial memory it will take.

Since:
  2.1.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `DEFAULT_INITIAL_CAPACITY`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ByteArrayOutputStream()`
  Creates a new byte array output stream.
  `ByteArrayOutputStream(int size)`
  Creates a new byte array output stream, with a buffer capacity of the specified size, in bytes.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `close()`
  Closing a `ByteArrayOutputStream` has no effect.
  `int`
  `getByte(int offset)`
  Gets the single byte value found at specified offset.
  `int`
  `getBytes(byte[] target, int offset)`
  Gets a byte array matching the specified offset and target byte array length.
  `void`
  `reset()`
  `int`
  `size()`
  Return the current size of the byte array.
  `static InputStream`
  `toBufferedInputStream(InputStream input)`
  Fetches entire contents of an `InputStream` and represent same data as result InputStream.
  `byte[]`
  `toByteArray()`
  Gets the current contents of this byte stream as a byte array.
  `String`
  `toString()`
  Gets the current contents of this byte stream as a string.
  `String`
  `toString(String enc)`
  Gets the current contents of this byte stream as a string using the specified encoding.
  `String`
  `toString(Charset enc)`
  Gets the current contents of this byte stream as a string using the specified encoding.
  `void`
  `write(@lombok.NonNull byte[] b, int off, int len)`
  Write the bytes to byte array.
  `void`
  `write(int b)`
  Write a byte to byte array.
  `int`
  `write(InputStream in)`
  Writes the entire contents of the specified input stream to this byte stream.
  `void`
  `writeTo(OutputStream out)`
  Writes the entire contents of this byte stream to the specified output stream.

  ### Methods inherited from class java.io.OutputStream

  `flush, nullOutputStream, write`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### DEFAULT_INITIAL_CAPACITY

    public static final int DEFAULT_INITIAL_CAPACITY
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### ByteArrayOutputStream

    public ByteArrayOutputStream()
    Creates a new byte array output stream. The buffer capacity is initially 1024 bytes.

  - ### ByteArrayOutputStream

    public ByteArrayOutputStream(int size)
    Creates a new byte array output stream, with a buffer capacity of the specified size, in bytes.
    Parameters:
      `size` - the initial size
    Throws:
      `IllegalArgumentException` - if size is negative

- ## Method Details

  - ### getByte

    public int getByte(int offset)
    Gets the single byte value found at specified offset. If the offset is larger than the byte array length, `-1` is returned. If the offset is lower than zero, zero is assumed.
    Parameters:
      `offset` - position to read the byte at.
    Returns:
      a decimal byte value

  - ### getBytes

    public int getBytes(byte[] target, int offset)
    Gets a byte array matching the specified offset and target byte array length. If the offset is larger than the byte array length, `-1` will be returned. If the offset is lower than zero, zero is assumed. If the target byte array length is larger than the byte array, the value returned will be lower than the specified length.
    Parameters:
      `target` - target byte array to store bytes into.
      `offset` - position to read the byte at.
    Returns:
      the number of bytes read

  - ### write

    public void write(@NonNull @lombok.NonNull byte[] b, int off, int len)
    Write the bytes to byte array.
    Overrides:
      `write` in class `OutputStream`
    Parameters:
      `b` - the bytes to write
      `off` - The start offset
      `len` - The number of bytes to write

  - ### write

    public void write(int b)
    Write a byte to byte array.
    Specified by:
      `write` in class `OutputStream`
    Parameters:
      `b` - the byte to write

  - ### write

    public int write(InputStream in) throws IOException
    Writes the entire contents of the specified input stream to this byte stream. Bytes from the input stream are read directly into the internal buffers of this streams.
    Parameters:
      `in` - the input stream to read from
    Returns:
      total number of bytes read from the input stream (and written to this stream)
    Throws:
      `IOException` - if an I/O error occurs while reading the input stream

  - ### size

    public int size()
    Return the current size of the byte array.
    Returns:
      the current size of the byte array

  - ### close

    public void close() throws IOException
    Closing a `ByteArrayOutputStream` has no effect. The methods in this class can be called after the stream has been closed without generating an `IOException`.
    Specified by:
      `close` in interface `AutoCloseable`
    Specified by:
      `close` in interface `Closeable`
    Overrides:
      `close` in class `OutputStream`
    Throws:
      `IOException` - never (this method should not declare this exception but it has to now due to backwards compatability)

  - ### reset

    public void reset()
    See Also:
      - `ByteArrayOutputStream.reset()`

  - ### writeTo

    public void writeTo(OutputStream out) throws IOException
    Writes the entire contents of this byte stream to the specified output stream.
    Parameters:
      `out` - the output stream to write to
    Throws:
      `IOException` - if an I/O error occurs, such as if the stream is closed
    See Also:
      - `ByteArrayOutputStream.writeTo(OutputStream)`

  - ### toBufferedInputStream

    public static InputStream toBufferedInputStream(InputStream input) throws IOException

    Fetches entire contents of an `InputStream` and represent same data as result InputStream.

    This method is useful where,

    - Source InputStream is slow.
    - It has network resources associated, so we cannot keep it open for long time.
    - It has network timeout associated.

    It can be used in favor of `toByteArray()`, since it avoids unnecessary allocation and copy of byte[].
    This method buffers the input internally, so there is no need to use a `BufferedInputStream`.

    This method closes the supplied input stream before returning a new one.

    Parameters:
      `input` - Stream to be fully buffered.
    Returns:
      A fully buffered stream.
    Throws:
      `IOException` - if an I/O error occurs

  - ### toByteArray

    public byte[] toByteArray()
    Gets the current contents of this byte stream as a byte array. The result is independent of this stream.
    Returns:
      the current contents of this output stream, as a byte array
    See Also:
      - `ByteArrayOutputStream.toByteArray()`

  - ### toString

    public String toString()
    Gets the current contents of this byte stream as a string.
    Overrides:
      `toString` in class `Object`
    Returns:
      the contents of the byte array as a String
    See Also:
      - `ByteArrayOutputStream.toString()`

  - ### toString

    public String toString(String enc) throws UnsupportedEncodingException
    Gets the current contents of this byte stream as a string using the specified encoding.
    Parameters:
      `enc` - the name of the character encoding
    Returns:
      the string converted from the byte array
    Throws:
      `UnsupportedEncodingException` - if the encoding is not supported
    See Also:
      - `ByteArrayOutputStream.toString(String)`

  - ### toString

    public String toString(Charset enc) throws UnsupportedEncodingException
    Gets the current contents of this byte stream as a string using the specified encoding.
    Parameters:
      `enc` - the character encoding
    Returns:
      the string converted from the byte array
    Throws:
      `UnsupportedEncodingException` - if the encoding is not supported
    Since:
      3.0.0
    See Also:
      - `ByteArrayOutputStream.toString(String)`